diff --git a/gtk/gtkfilechooserentry.c b/gtk/gtkfilechooserentry.c
index 3caa7b8..7350793 100644
--- a/gtk/gtkfilechooserentry.c
+++ b/gtk/gtkfilechooserentry.c
@@ -1277,420 +442,234 @@ gtk_file_chooser_entry_focus_out_event (GtkWidget     *widget,
 {
   GtkFileChooserEntry *chooser_entry = GTK_FILE_CHOOSER_ENTRY (widget);
 
-  chooser_entry->load_complete_action = LOAD_COMPLETE_NOTHING;
+  set_complete_on_load (chooser_entry, FALSE);
  
   return GTK_WIDGET_CLASS (_gtk_file_chooser_entry_parent_class)->focus_out_event (widget, event);
 }
 
 static void
-commit_completion_and_refresh (GtkFileChooserEntry *chooser_entry)
+update_inline_completion (GtkFileChooserEntry *chooser_entry)
 {
-  if (chooser_entry->has_completion)
+  GtkEntryCompletion *completion = gtk_entry_get_completion (GTK_ENTRY (chooser_entry));
+
+  if (!chooser_entry->current_folder_loaded)
     {
-      gtk_editable_set_position (GTK_EDITABLE (chooser_entry),
-				 gtk_entry_get_text_length (GTK_ENTRY (chooser_entry)));
+      gtk_entry_completion_set_inline_completion (completion, FALSE);
+      return;
     }
 
-  /* Here we ignore the result of refresh_current_folder_and_file_part(); there is nothing we can do with it */
-  refresh_current_folder_and_file_part (chooser_entry, REFRESH_WHOLE_TEXT);
+  switch (chooser_entry->action)
+    {
+    case GTK_FILE_CHOOSER_ACTION_OPEN:
+    case GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER:
+      gtk_entry_completion_set_inline_completion (completion, TRUE);
+      break;
+    case GTK_FILE_CHOOSER_ACTION_SAVE:
+    case GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER:
+      gtk_entry_completion_set_inline_completion (completion, FALSE);
+      break;
+    }
 }
 
 static void
-gtk_file_chooser_entry_activate (GtkEntry *entry)
+discard_completion_store (GtkFileChooserEntry *chooser_entry)
 {
-  GtkFileChooserEntry *chooser_entry = GTK_FILE_CHOOSER_ENTRY (entry);
+  if (!chooser_entry->completion_store)
+    return;
 
-  commit_completion_and_refresh (chooser_entry);
-  GTK_ENTRY_CLASS (_gtk_file_chooser_entry_parent_class)->activate (entry);
+  gtk_entry_completion_set_model (gtk_entry_get_completion (GTK_ENTRY (chooser_entry)), NULL);
+  update_inline_completion (chooser_entry);
+  g_object_unref (chooser_entry->completion_store);
+  chooser_entry->completion_store = NULL;
 }
 
-/* Fills the completion store from the contents of the current folder */
-static void
-populate_completion_store (GtkFileChooserEntry *chooser_entry)
+static gboolean
+completion_store_set (GtkFileSystemModel  *model,
+                      GFile               *file,
+                      GFileInfo           *info,
+                      int                  column,
+                      GValue              *value,
+                      gpointer             data)
 {
-  GSList *files;
-  GSList *tmp_list;
-
-  discard_completion_store (chooser_entry);
-
-  files = _gtk_folder_list_children (chooser_entry->current_folder);
-
-  chooser_entry->completion_store = gtk_list_store_new (N_COLUMNS,
-							G_TYPE_STRING,
-							G_TYPE_FILE);
-
-  for (tmp_list = files; tmp_list; tmp_list = tmp_list->next)
-    {
-      GFileInfo *info;
-      GFile *file;
-
-      file = tmp_list->data;
-
-      info = _gtk_folder_get_info (chooser_entry->current_folder, file);
-
-      if (info)
-	{
-	  gchar *display_name = g_strdup (g_file_info_get_display_name (info));
-	  GtkTreeIter iter;
-	  gboolean dummy;
-
-          display_name = maybe_append_separator_to_file (chooser_entry, file, display_name, &dummy);
-
-	  gtk_list_store_append (chooser_entry->completion_store, &iter);
-	  gtk_list_store_set (chooser_entry->completion_store, &iter,
-			      DISPLAY_NAME_COLUMN, display_name,
-			      FILE_COLUMN, file,
-			      -1);
-
-	  g_object_unref (info);
-          g_free (display_name);
-	}
-    }
-
-  g_slist_foreach (files, (GFunc) g_object_unref, NULL);
-  g_slist_free (files);
-
-  gtk_tree_sortable_set_sort_column_id (GTK_TREE_SORTABLE (chooser_entry->completion_store),
-					DISPLAY_NAME_COLUMN, GTK_SORT_ASCENDING);
+  GtkFileChooserEntry *chooser_entry = data;
 
-  gtk_entry_completion_set_model (gtk_entry_get_completion (GTK_ENTRY (chooser_entry)),
-				  GTK_TREE_MODEL (chooser_entry->completion_store));
-}
+  const char *prefix = "";
+  const char *suffix = "";
 
-/* When we finish loading the current folder, this function should get called to
- * perform the deferred autocompletion or explicit completion.
- */
-static void
-perform_load_complete_action (GtkFileChooserEntry *chooser_entry)
-{
-  switch (chooser_entry->load_complete_action)
+  switch (column)
     {
-    case LOAD_COMPLETE_NOTHING:
-      break;
-
-    case LOAD_COMPLETE_AUTOCOMPLETE:
-      autocomplete (chooser_entry);
-      break;
+    case FULL_PATH_COLUMN:
+      prefix = chooser_entry->dir_part;
+      /* fall through */
+    case DISPLAY_NAME_COLUMN:
+      if (_gtk_file_info_consider_as_directory (info))
+        suffix = G_DIR_SEPARATOR_S;
 
-    case LOAD_COMPLETE_EXPLICIT_COMPLETION:
-      explicitly_complete (chooser_entry);
+      g_value_take_string (value,
+			   g_strconcat (prefix,
+					g_file_info_get_display_name (info),
+					suffix,
+					NULL));
       break;
-
     default:
       g_assert_not_reached ();
+      break;
     }
 
-  chooser_entry->load_complete_action = LOAD_COMPLETE_NOTHING;
+  return TRUE;
 }
 
+/* Fills the completion store from the contents of the current folder */
 static void
-finish_folder_load (GtkFileChooserEntry *chooser_entry)
+populate_completion_store (GtkFileChooserEntry *chooser_entry)
 {
-  populate_completion_store (chooser_entry);
-  perform_load_complete_action (chooser_entry);
+  chooser_entry->completion_store = GTK_TREE_MODEL (
+      _gtk_file_system_model_new_for_directory (chooser_entry->current_folder_file,
+                                                "standard::name,standard::display-name,standard::type",
+                                                completion_store_set,
+                                                chooser_entry,
+                                                N_COLUMNS,
+                                                G_TYPE_STRING,
+                                                G_TYPE_STRING));
+  g_signal_connect (chooser_entry->completion_store, "finished-loading",
+		    G_CALLBACK (finished_loading_cb), chooser_entry);
+
+  _gtk_file_system_model_set_filter_folders (GTK_FILE_SYSTEM_MODEL (chooser_entry->completion_store),
+                                             TRUE);
+  _gtk_file_system_model_set_show_files (GTK_FILE_SYSTEM_MODEL (chooser_entry->completion_store),
+                                         chooser_entry->action == GTK_FILE_CHOOSER_ACTION_OPEN ||
+                                         chooser_entry->action == GTK_FILE_CHOOSER_ACTION_SAVE);
+  gtk_tree_sortable_set_sort_column_id (GTK_TREE_SORTABLE (chooser_entry->completion_store),
+					DISPLAY_NAME_COLUMN, GTK_SORT_ASCENDING);
 
-  gtk_widget_set_tooltip_text (GTK_WIDGET (chooser_entry), NULL);
+  gtk_entry_completion_set_model (gtk_entry_get_completion (GTK_ENTRY (chooser_entry)),
+				  chooser_entry->completion_store);
 }
 
 /* Callback when the current folder finishes loading */
 static void
-finished_loading_cb (GtkFolder *folder,
-		     gpointer   data)
-{
-  GtkFileChooserEntry *chooser_entry = GTK_FILE_CHOOSER_ENTRY (data);
-
-  finish_folder_load (chooser_entry);
-}
-
-/* Callback when the current folder's handle gets obtained (not necessarily loaded completely) */
-static void
-load_directory_get_folder_callback (GCancellable  *cancellable,
-				    GtkFolder     *folder,
-				    const GError  *error,
-				    gpointer       data)
+finished_loading_cb (GtkFileSystemModel  *model,
+                     GError              *error,
+		     GtkFileChooserEntry *chooser_entry)
 {
-  gboolean cancelled = g_cancellable_is_cancelled (cancellable);
-  GtkFileChooserEntry *chooser_entry = data;
-
-  if (cancellable != chooser_entry->load_folder_cancellable)
-    goto out;
+  GtkEntryCompletion *completion;
 
-  chooser_entry->load_folder_cancellable = NULL;
+  chooser_entry->current_folder_loaded = TRUE;
 
   if (error)
     {
-      LoadCompleteAction old_load_complete_action;
-
-      old_load_complete_action = chooser_entry->load_complete_action;
-
       discard_completion_store (chooser_entry);
-      clear_completions (chooser_entry);
-
-      if (old_load_complete_action == LOAD_COMPLETE_EXPLICIT_COMPLETION)
-	{
-	  /* Since this came from explicit user action (Tab completion), we'll present errors visually */
-
-	  beep (chooser_entry);
-	  pop_up_completion_feedback (chooser_entry, error->message);
-	}
-
-      discard_current_folder (chooser_entry);
+      set_complete_on_load (chooser_entry, FALSE);
+      return;
     }
 
-  if (cancelled || error)
-    goto out;
+  if (chooser_entry->complete_on_load)
+    explicitly_complete (chooser_entry);
 
-  g_assert (folder != NULL);
-  chooser_entry->current_folder = g_object_ref (folder);
-
-  discard_completion_store (chooser_entry);
+  gtk_widget_set_tooltip_text (GTK_WIDGET (chooser_entry), NULL);
 
-  if (_gtk_folder_is_finished_loading (chooser_entry->current_folder))
-    finish_folder_load (chooser_entry);
-  else
-    g_signal_connect (chooser_entry->current_folder, "finished-loading",
-		      G_CALLBACK (finished_loading_cb), chooser_entry);
+  completion = gtk_entry_get_completion (GTK_ENTRY (chooser_entry));
+  update_inline_completion (chooser_entry);
 
-out:
-  g_object_unref (chooser_entry);
-  g_object_unref (cancellable);
+  if (gtk_widget_has_focus (GTK_WIDGET (chooser_entry)))
+    {
+      gtk_entry_completion_complete (completion);
+      gtk_entry_completion_insert_prefix (completion);
+    }
 }
 
-static RefreshStatus
-start_loading_current_folder (GtkFileChooserEntry *chooser_entry)
+static void
+set_completion_folder (GtkFileChooserEntry *chooser_entry,
+                       GFile               *folder_file,
+		       char                *dir_part)
 {
-  if (chooser_entry->file_system == NULL)
-    return REFRESH_OK;
+  if (folder_file &&
+      chooser_entry->local_only
+      && !_gtk_file_has_native_path (folder_file))
+    folder_file = NULL;
 
-  g_assert (chooser_entry->current_folder_file != NULL);
-  g_assert (chooser_entry->current_folder == NULL);
-  g_assert (chooser_entry->load_folder_cancellable == NULL);
+  if (((chooser_entry->current_folder_file
+	&& folder_file
+	&& g_file_equal (folder_file, chooser_entry->current_folder_file))
+       || chooser_entry->current_folder_file == folder_file)
+      && g_strcmp0 (dir_part, chooser_entry->dir_part) == 0)
+    {
+      return;
+    }
 
-  if (chooser_entry->local_only
-      && !_gtk_file_has_native_path (chooser_entry->current_folder_file))
+  if (chooser_entry->current_folder_file)
     {
       g_object_unref (chooser_entry->current_folder_file);
       chooser_entry->current_folder_file = NULL;
-
-      return REFRESH_NOT_LOCAL;
     }
 
-  chooser_entry->load_folder_cancellable =
-    _gtk_file_system_get_folder (chooser_entry->file_system,
-			         chooser_entry->current_folder_file,
-			 	"standard::name,standard::display-name,standard::type",
-			         load_directory_get_folder_callback,
-			         g_object_ref (chooser_entry));
-
-  return REFRESH_OK;
-}
-
-static RefreshStatus
-reload_current_folder (GtkFileChooserEntry *chooser_entry,
-		       GFile               *folder_file,
-		       gboolean             force_reload)
-{
-  gboolean reload = FALSE;
-
-  g_assert (folder_file != NULL);
-
-  if (chooser_entry->current_folder_file)
-    {
-      if ((!(g_file_equal (folder_file, chooser_entry->current_folder_file)
-	     && chooser_entry->load_folder_cancellable))
-	  || force_reload)
-	{
-	  reload = TRUE;
+  g_free (chooser_entry->dir_part);
+  chooser_entry->dir_part = g_strdup (dir_part);
+  
+  chooser_entry->current_folder_loaded = FALSE;
 
-          discard_current_folder (chooser_entry);
-	  discard_loading_and_current_folder_file (chooser_entry);
+  discard_completion_store (chooser_entry);
 
-	  chooser_entry->current_folder_file = g_object_ref (folder_file);
-	}
-    }
-  else
+  if (folder_file)
     {
       chooser_entry->current_folder_file = g_object_ref (folder_file);
-      reload = TRUE;
+      populate_completion_store (chooser_entry);
     }
-
-  if (reload)
-    return start_loading_current_folder (chooser_entry);
-  else
-    return REFRESH_OK;
 }
 
-static RefreshStatus
-refresh_current_folder_and_file_part (GtkFileChooserEntry *chooser_entry,
-				      RefreshMode          refresh_mode)
+static void
+refresh_current_folder_and_file_part (GtkFileChooserEntry *chooser_entry)
 {
-  GtkEditable *editable;
-  gint end_pos;
-  gchar *text;
   GFile *folder_file;
-  gchar *file_part;
-  gsize total_len, file_part_len;
-  gint file_part_pos;
-  GError *error;
-  RefreshStatus result;
+  char *text, *last_slash, *old_file_part;
+  char *dir_part;
 
-  editable = GTK_EDITABLE (chooser_entry);
+  old_file_part = chooser_entry->file_part;
 
-  switch (refresh_mode)
-    {
-    case REFRESH_UP_TO_CURSOR_POSITION:
-      end_pos = gtk_editable_get_position (editable);
-      break;
-
-    case REFRESH_WHOLE_TEXT:
-      end_pos = gtk_entry_get_text_length (GTK_ENTRY (chooser_entry));
-      break;
-
-    default:
-      g_assert_not_reached ();
-      return REFRESH_INVALID_INPUT;
-    }
+  text = gtk_file_chooser_entry_get_completion_text (chooser_entry);
 
-  text = gtk_editable_get_chars (editable, 0, end_pos);
-
-  error = NULL;
-  if (!chooser_entry->file_system ||
-      !_gtk_file_system_parse (chooser_entry->file_system,
-			       chooser_entry->base_folder, text,
-			       &folder_file, &file_part, &error))
+  last_slash = strrchr (text, G_DIR_SEPARATOR);
+  if (last_slash)
     {
-      if (g_error_matches (error, GTK_FILE_CHOOSER_ERROR, GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME))
-	{
-	  folder_file = NULL;
-	  result = REFRESH_INCOMPLETE_HOSTNAME;
-	}
-      else
-	{
-	  folder_file = (chooser_entry->base_folder) ? g_object_ref (chooser_entry->base_folder) : NULL;
-
-	  if (g_error_matches (error, GTK_FILE_CHOOSER_ERROR, GTK_FILE_CHOOSER_ERROR_NONEXISTENT))
-	    result = REFRESH_NONEXISTENT;
-	  else
-	    result = REFRESH_INVALID_INPUT;
-	}
-
-      if (error)
-	g_error_free (error);
-
-      file_part = g_strdup ("");
-      file_part_pos = -1;
+      dir_part = g_strndup (text, last_slash - text + 1);
+      chooser_entry->file_part = g_strdup (last_slash + 1);
     }
   else
     {
-      g_assert (folder_file != NULL);
-
-      file_part_len = strlen (file_part);
-      total_len = strlen (text);
-      if (total_len > file_part_len)
-	file_part_pos = g_utf8_strlen (text, total_len - file_part_len);
-      else
-	file_part_pos = 0;
-
-      result = REFRESH_OK;
+      dir_part = g_strdup ("");
+      chooser_entry->file_part = g_strdup (text);
     }
 
-  g_free (text);
-
-  g_free (chooser_entry->file_part);
-
-  chooser_entry->file_part = file_part;
-  chooser_entry->file_part_pos = file_part_pos;
+  folder_file = gtk_file_chooser_get_directory_for_text (chooser_entry, text);
 
-  if (result == REFRESH_OK)
-    {
-      result = reload_current_folder (chooser_entry, folder_file, file_part_pos == -1);
-    }
-  else
-    {
-      discard_current_folder (chooser_entry);
-      discard_loading_and_current_folder_file (chooser_entry);
-    }
+  set_completion_folder (chooser_entry, folder_file, dir_part);
 
   if (folder_file)
     g_object_unref (folder_file);
 
-  g_assert (/* we are OK and we have a current folder file and (loading process or folder handle)... */
-	    ((result == REFRESH_OK)
-	     && (chooser_entry->current_folder_file != NULL)
-	     && (((chooser_entry->load_folder_cancellable != NULL) && (chooser_entry->current_folder == NULL))
-		 || ((chooser_entry->load_folder_cancellable == NULL) && (chooser_entry->current_folder != NULL))))
-	    /* ... OR we have an error, and we don't have a current folder file nor a loading process nor a folder handle */
-	    || ((result != REFRESH_OK)
-		&& (chooser_entry->current_folder_file == NULL)
-		&& (chooser_entry->load_folder_cancellable == NULL)
-		&& (chooser_entry->current_folder == NULL)));
-
-  return result;
-}
-
-static void
-autocomplete (GtkFileChooserEntry *chooser_entry)
-{
-  if (!(chooser_entry->current_folder != NULL
-	&& _gtk_folder_is_finished_loading (chooser_entry->current_folder)
-	&& gtk_editable_get_position (GTK_EDITABLE (chooser_entry)) == gtk_entry_get_text_length (GTK_ENTRY (chooser_entry))))
-    return;
-
-  append_common_prefix (chooser_entry, TRUE, FALSE);
-}
-
-static void
-start_autocompletion (GtkFileChooserEntry *chooser_entry)
-{
-  RefreshStatus status;
-
-  status = refresh_current_folder_and_file_part (chooser_entry, REFRESH_UP_TO_CURSOR_POSITION);
+  g_free (dir_part);
 
-  switch (status)
+  if (chooser_entry->completion_store &&
+      (g_strcmp0 (old_file_part, chooser_entry->file_part) != 0))
     {
-    case REFRESH_OK:
-      g_assert (chooser_entry->current_folder_file != NULL);
+      GtkFileFilter *filter;
+      char *pattern;
 
-      if (chooser_entry->current_folder && _gtk_folder_is_finished_loading (chooser_entry->current_folder))
-	autocomplete (chooser_entry);
-      else
-	chooser_entry->load_complete_action = LOAD_COMPLETE_AUTOCOMPLETE;
+      filter = gtk_file_filter_new ();
+      pattern = g_strconcat (chooser_entry->file_part, "*", NULL);
+      gtk_file_filter_add_pattern (filter, pattern);
 
-      break;
+      g_object_ref_sink (filter);
 
-    case REFRESH_INVALID_INPUT:
-    case REFRESH_INCOMPLETE_HOSTNAME:
-    case REFRESH_NONEXISTENT:
-    case REFRESH_NOT_LOCAL:
-      /* We don't beep or anything, since this is autocompletion - the user
-       * didn't request any action explicitly.
-       */
-      break;
+      _gtk_file_system_model_set_filter (GTK_FILE_SYSTEM_MODEL (chooser_entry->completion_store),
+                                         filter);
 
-    default:
-      g_assert_not_reached ();
+      g_free (pattern);
+      g_object_unref (filter);
     }
-}
-
-static gboolean
-start_autocompletion_idle_handler (gpointer data)
-{
-  GtkFileChooserEntry *chooser_entry = GTK_FILE_CHOOSER_ENTRY (data);
-
-  start_autocompletion (chooser_entry);
 
-  chooser_entry->start_autocompletion_idle_id = 0;
-
-  return FALSE;
-}
-
-static void
-install_start_autocompletion_idle (GtkFileChooserEntry *chooser_entry)
-{
-  if (chooser_entry->start_autocompletion_idle_id != 0)
-    return;
-
-  chooser_entry->start_autocompletion_idle_id = gdk_threads_add_idle (start_autocompletion_idle_handler, chooser_entry);
+  g_free (text);
+  g_free (old_file_part);
 }
 
 #ifdef G_OS_WIN32
@@ -1769,7 +748,7 @@ delete_text_callback (GtkFileChooserEntry *chooser_entry,
  * Return value: the newly created #GtkFileChooserEntry
  **/
 GtkWidget *
-_gtk_file_chooser_entry_new (gboolean eat_tabs)
+_gtk_file_chooser_entry_new (gboolean       eat_tabs)
 {
   GtkFileChooserEntry *chooser_entry;
 
@@ -1780,29 +759,6 @@ _gtk_file_chooser_entry_new (gboolean eat_tabs)
 }
 
 /**
- * _gtk_file_chooser_entry_set_file_system:
- * @chooser_entry: a #GtkFileChooser
- * @file_system: an object implementing #GtkFileSystem
- *
- * Sets the file system for @chooser_entry.
- **/
-void
-_gtk_file_chooser_entry_set_file_system (GtkFileChooserEntry *chooser_entry,
-					 GtkFileSystem       *file_system)
-{
-  g_return_if_fail (GTK_IS_FILE_CHOOSER_ENTRY (chooser_entry));
-  g_return_if_fail (GTK_IS_FILE_SYSTEM (file_system));
-
-  if (file_system != chooser_entry->file_system)
-    {
-      if (chooser_entry->file_system)
-	g_object_unref (chooser_entry->file_system);
-
-      chooser_entry->file_system = g_object_ref (file_system);
-    }
-}
-
-/**
  * _gtk_file_chooser_entry_set_base_folder:
  * @chooser_entry: a #GtkFileChooserEntry
  * @file: file for a folder in the chooser entries current file system.
@@ -1813,15 +769,23 @@ void
 _gtk_file_chooser_entry_set_base_folder (GtkFileChooserEntry *chooser_entry,
 					 GFile               *file)
 {
+  g_return_if_fail (GTK_IS_FILE_CHOOSER_ENTRY (chooser_entry));
+  g_return_if_fail (file == NULL || G_IS_FILE (file));
+
+  if (chooser_entry->base_folder == file ||
+      (file != NULL && chooser_entry->base_folder != NULL 
+       && g_file_equal (chooser_entry->base_folder, file)))
+    return;
+
+  if (file)
+    g_object_ref (file);
+
   if (chooser_entry->base_folder)
     g_object_unref (chooser_entry->base_folder);
 
   chooser_entry->base_folder = file;
 
-  if (chooser_entry->base_folder)
-    g_object_ref (chooser_entry->base_folder);
-
-  clear_completions (chooser_entry);
+  refresh_current_folder_and_file_part (chooser_entry);
 }
 
 /**
@@ -1835,14 +799,16 @@ _gtk_file_chooser_entry_set_base_folder (GtkFileChooserEntry *chooser_entry,
  * be different.  If the user has entered unparsable text, or text which
  * the entry cannot handle, this will return %NULL.
  *
- * Return value: the file for the current folder - this value is owned by the
- *  chooser entry and must not be modified or freed.
+ * Return value: the file for the current folder - you must g_object_unref()
+ *   the value after use.
  **/
 GFile *
 _gtk_file_chooser_entry_get_current_folder (GtkFileChooserEntry *chooser_entry)
 {
-  commit_completion_and_refresh (chooser_entry);
-  return chooser_entry->current_folder_file;
+  g_return_val_if_fail (GTK_IS_FILE_CHOOSER_ENTRY (chooser_entry), NULL);
+
+  return gtk_file_chooser_get_directory_for_text (chooser_entry,
+                                                  gtk_entry_get_text (GTK_ENTRY (chooser_entry)));
 }
 
 /**
@@ -1860,30 +826,20 @@ _gtk_file_chooser_entry_get_current_folder (GtkFileChooserEntry *chooser_entry)
 const gchar *
 _gtk_file_chooser_entry_get_file_part (GtkFileChooserEntry *chooser_entry)
 {
-  commit_completion_and_refresh (chooser_entry);
-  return chooser_entry->file_part;
-}
+  const char *last_slash, *text;
 
-/**
- * _gtk_file_chooser_entry_set_file_part:
- * @chooser_entry: a #GtkFileChooserEntry
- * @file_part: text to display in the entry, in UTF-8
- *
- * Sets the current text shown in the file chooser entry.
- **/
-void
-_gtk_file_chooser_entry_set_file_part (GtkFileChooserEntry *chooser_entry,
-				       const gchar         *file_part)
-{
-  g_return_if_fail (GTK_IS_FILE_CHOOSER_ENTRY (chooser_entry));
+  g_return_val_if_fail (GTK_IS_FILE_CHOOSER_ENTRY (chooser_entry), NULL);
 
-  chooser_entry->in_change = TRUE;
-  clear_completions (chooser_entry);
-  gtk_entry_set_text (GTK_ENTRY (chooser_entry), file_part);
-  chooser_entry->in_change = FALSE;
+  text = gtk_entry_get_text (GTK_ENTRY (chooser_entry));
+  last_slash = strrchr (text, G_DIR_SEPARATOR);
+  if (last_slash)
+    return last_slash + 1;
+  else if (is_directory_shortcut (text))
+    return "";
+  else
+    return text;
 }
 
-
 /**
  * _gtk_file_chooser_entry_set_action:
  * @chooser_entry: a #GtkFileChooserEntry
@@ -1920,6 +876,13 @@ _gtk_file_chooser_entry_set_action (GtkFileChooserEntry *chooser_entry,
 	  gtk_entry_completion_set_popup_single_match (comp, TRUE);
 	  break;
 	}
+
+      if (chooser_entry->completion_store)
+        _gtk_file_system_model_set_show_files (GTK_FILE_SYSTEM_MODEL (chooser_entry->completion_store),
+                                               action == GTK_FILE_CHOOSER_ACTION_OPEN ||
+                                               action == GTK_FILE_CHOOSER_ACTION_SAVE);
+
+      update_inline_completion (chooser_entry);
     }
 }
 
@@ -1945,22 +908,19 @@ gboolean
 _gtk_file_chooser_entry_get_is_folder (GtkFileChooserEntry *chooser_entry,
 				       GFile               *file)
 {
-  gboolean retval = FALSE;
-
-  if (chooser_entry->current_folder)
-    {
-      GFileInfo *file_info;
+  GtkTreeIter iter;
+  GFileInfo *info;
 
-      file_info = _gtk_folder_get_info (chooser_entry->current_folder, file);
+  if (chooser_entry->completion_store == NULL ||
+      !_gtk_file_system_model_get_iter_for_file (GTK_FILE_SYSTEM_MODEL (chooser_entry->completion_store),
+                                                 &iter,
+                                                 file))
+    return FALSE;
 
-      if (file_info)
-        {
-	  retval = _gtk_file_info_consider_as_directory (file_info);
-	  g_object_unref (file_info);
-	}
-    }
+  info = _gtk_file_system_model_get_info (GTK_FILE_SYSTEM_MODEL (chooser_entry->completion_store),
+                                          &iter);
 
-  return retval;
+  return _gtk_file_info_consider_as_directory (info);
 }
 
 
@@ -1993,7 +953,7 @@ _gtk_file_chooser_entry_set_local_only (GtkFileChooserEntry *chooser_entry,
                                         gboolean             local_only)
 {
   chooser_entry->local_only = local_only;
-  clear_completions (chooser_entry);
+  refresh_current_folder_and_file_part (chooser_entry);
 }
 
 gboolean
diff --git a/gtk/gtkfilechooserentry.h b/gtk/gtkfilechooserentry.h
index a9c9f83..216b8ae 100644
--- a/gtk/gtkfilechooserentry.h
+++ b/gtk/gtkfilechooserentry.h
@@ -33,16 +33,12 @@ G_BEGIN_DECLS
 typedef struct _GtkFileChooserEntry      GtkFileChooserEntry;
 
 GType              _gtk_file_chooser_entry_get_type           (void) G_GNUC_CONST;
-GtkWidget *        _gtk_file_chooser_entry_new                (gboolean eat_tab);
+GtkWidget *        _gtk_file_chooser_entry_new                (gboolean             eat_tab);
 void               _gtk_file_chooser_entry_set_action         (GtkFileChooserEntry *chooser_entry,
 							       GtkFileChooserAction action);
 GtkFileChooserAction _gtk_file_chooser_entry_get_action       (GtkFileChooserEntry *chooser_entry);
-void               _gtk_file_chooser_entry_set_file_system    (GtkFileChooserEntry *chooser_entry,
-							       GtkFileSystem       *file_system);
 void               _gtk_file_chooser_entry_set_base_folder    (GtkFileChooserEntry *chooser_entry,
 							       GFile               *folder);
-void               _gtk_file_chooser_entry_set_file_part      (GtkFileChooserEntry *chooser_entry,
-							       const gchar         *file_part);
 GFile *            _gtk_file_chooser_entry_get_current_folder (GtkFileChooserEntry *chooser_entry);
 const gchar *      _gtk_file_chooser_entry_get_file_part      (GtkFileChooserEntry *chooser_entry);
 gboolean           _gtk_file_chooser_entry_get_is_folder      (GtkFileChooserEntry *chooser_entry,
